.code16

#include "globals.h"

STAGE2_NUM_SECTORS = 63

stack = 0x2000

.section ".text"
.global _start
_start:
	/* setup stack */
	mov	$0x0,	%ax
	mov	%ax,	%ss
	mov	%ax,	%ds
	mov	%ax,	%es
	mov	$stack, %sp

	ljmp $0, $real_start

real_start:
	/* read stage 2 and pass control to it */
	mov $dap, %si
	movw $STAGE2_NUM_SECTORS, 2(%si)
	movw $STAGE2_ADDR, 4(%si)
	movw $STAGE2_SEG, 6(%si)
	movl $1, 8(%si)

	mov $0x42, %ah
	mov $0x80, %dl
	int $0x13

	ljmp $STAGE2_SEG, $STAGE2_ADDR
	jmp .

dap:
	.byte 0x10	/* size */
	.byte 0		/* sbz */
	.word 0		/* num sectors */
	.word 0		/* buffer offset */
	.word 0		/* buffer segment */
	.long 0		/* first sector low */
	.long 0		/* first sector high */

. = _start +0x1b8
	/* disk id */
	.long 0xe4de2a82

. = _start + 0x1be
	/* status */
	.byte 0
	/* chs start */
	.byte 0x20
	.byte 0x21
	.byte 0
	/* type */
	.byte 0x83
	/* chs end */
	.byte 0x5f
	.byte 0x19
	.byte 0x6
	/* lba start */
	.long 0x800
	/* lba size */
	.long 0x18800
	
. = _start + 0x1fe
	.word 0xaa55
